<link rel="import" href="../dez-canvas/dez-canvas.html">

<script src="lib/MusicalMap.js"></script>
<script src="lib/ScoreView.js"></script>
<script src="lib/utils.js"></script>

<!--

@demo ./demo/index.html Demo

-->

<dom-module id="dez-music-canvas">

    <template>

        <style>

            :host {
                display: flex;
                flex-direction: column;
            }

            dez-canvas {
                flex-grow: 1;
            }

        </style>

        <!-- scrollLeft is only used for upward data flow -->
        <dez-canvas id="canvas" bg="[[image]]" grid-data="[[gridData]]" zoom="[[zoom]]" scroll-left="{{scrollLeft}}"></dez-canvas>

        <iron-ajax
            id="positionsFileRequest"
            handle-as="json"
            debounce-duration="300"
            on-response="_positionsReady">
        </iron-ajax>

        <iron-ajax
            id="synchroFileRequest"
            url="[[audioSynchro]]"
            handle-as="json"
            debounce-duration="300"
            auto
            on-response="_synchroReady">
        </iron-ajax>

    </template>

    <script>

        class DezMusicCanvas extends Polymer.Element {

            static get is() { return 'dez-music-canvas'; }

            static get properties() {
                return {
                    jwt : {
                      type : String,
                      value : ""
                    },
                    image : String,
                    positionsFile : {
                        type: String,
                        observer: '_positionsAttChanged'
                    },
                    // scrollLeft is only used for upward data flow
                    // it cannot be modified
                    scrollLeft: {
                        type: Number,
                        notify: true,
                        reflectToAttribute: true
                    },
                    // onset is calculated from scrollLeft
                    // it cannot be modified
                    onset: {
                        type: Number,
                        notify: true,
                        readonly: true,
                        reflectToAttribute: true,
                        computed: '_scrollXToOnset(scrollLeft)'
                    },
                    lastOffset: {
                      type: Number,
                      value: undefined,
                    },
                    zoom: {
                        type: Number,
                        value: 1,
                    },
                    type : {
                        type: String,
                        value: "score"
                    },
                    currentDate: {
                      type: Number,
                      observer: '_currentDateChanged'
                    },
                    audioSynchro: String
                }
            }

            set source (value) {
              this.type = value.type
              this.image = value.image
              this.$.positionsFileRequest.url = value.positions
              this.$.positionsFileRequest.headers['Authorization'] = this.jwt?'Bearer ' + this.jwt:""
              this.$.positionsFileRequest.generateRequest()

            }

            get synchro () { return this._synchro }

            _synchroReady (event) {
              this._synchro = new Synchro(event.detail.response)
              if (this.isWave() && this._positionsLoaded) {
                this._setGrid(this._positionsData);
                this._setView(this._positionsData);
                this._drawLabelsInit()
              }
            }

            _currentDateChanged () {
              if (this.currentDate != undefined) {
                this.$.canvas.cursor = this.map.toGraphicalX(
                  this._synchro.toOnset(this.currentDate)
                )
              } else {
                this.$.canvas.cursor = undefined
              }
            }

            constructor () {
              super();
              this._positionsLoaded = false;
              this._currentLineIndex = 3
              this._lastOnsetFirstStaff = 0
            }

            set analysis (analysis) {
              this._analysis = analysis;
              this._labelTypes = this._analysis.labelTypes;
              this._setCanvasDefault()
              this._analysis.addEventListener('analysis-ready', event => {
                this._drawLabelsInit()
              })
              this._analysis.addEventListener('analysis-erased', event => {
                if (this._view) this._view.resetLabels();
              })
              this._analysis.addEventListener('label-set', event => {
                if (event.detail.doneBy != this.id) {
                  this._view.redraw(event.detail.label);
                }
              })
							this._analysis.addEventListener('label-removed', event => {
                if (event.detail.doneBy != this.id) {
                  this._view.remove(event.detail.labelId);
                }
              })
							this._analysis.addEventListener('label-created', event => {
                if (!this._analysis.loadingAnalysis && event.detail.doneBy != this.id) {
                  let label = event.detail.label
                  if (label.start == undefined) {
                    if (this.currentDate != undefined) {
                      label.start = this._synchro.toOnset(this.currentDate)
                    } else {
                      label.start = 0
                    }
                  }
                  this._view.draw(label)
                }
              })
							this._analysis.addEventListener('label-selected', event => {
                if (event.detail.doneBy != this.id) {
                  this._view.selected(event.detail.label)
                }
              })
              this._analysis.addEventListener('label-model-changed', event => {
                this._setCanvasDefault()
              })
            }

            _positionsReady (event) {
              this._positionsLoaded = true;
              this._positionsData = event.detail.response
              this._setGrid(this._positionsData);
              this._setView(this._positionsData);
              this._drawLabelsInit()
            }

            _positionsAttChanged () {
              this._positionsLoaded = false;
            }

            _drawLabelsInit () {
              if (this.isWave() && this._synchro == undefined) return
              if (!this._analysis.loadingAnalysis && this._positionsLoaded) {
                this._view.labelTypes = this._labelTypes;
                this._view.resetLabels();
                this._analysis.labels.forEach(label => {
                  this._view.draw(label)
                })
                this._currentDateChanged()
								this._analysis.backupNeeded = false
              }
            }

            isScore() { return this.type == "score" }
            isWave() { return this.type == "wave" }

            _handleGrobChangedEvent (grob) {
                let label = this._view.toLabel(grob);
                if (grob.action == "CREATED") {
                  label.type = this._analysis.currentLabelModel.type
                  label.tag = this._analysis.currentLabelModel.tag
                  label = this._analysis.addLabel(label, this.id);
                  this._view.associateIds(label, grob.id)
                  this._analysis.selectLabel(label.id, this.id)
                } else if (grob.action == "SELECTED") {
                  this._analysis.selectLabel(label.id, this.id)
                  this.dispatchEvent(new CustomEvent(
                    'new-label-selection',
                    { detail : { label : label }}
                  ))
                } else if (grob.action == "PLAY") {
                  this._handleCursorChangedEvent(grob.x)
                } else if (grob.action == "DELETE") {
                  this._analysis.removeLabel(label.id, this.id);
                } else {
                  this._analysis.setLabel(label, this.id);
                  this._analysis.selectLabel(label.id, this.id)
                }
								// only to set current grob color in canvas
								this._setCanvasDefault()
            }

            _setCanvasDefault () {
              let color = this._labelTypes.colorOfType(
                this._analysis.currentLabelModel
              ).hex
                this.$.canvas.setDefaultValues({
                    "Rectangle": {
                        "text": this._analysis.currentLabelModel.tag,
                        "color": color,
                        "canBeOnSeveralLines": false
                    },
                    "VerticalLine": {
                        "text": this._analysis.currentLabelModel.tag,
                        "color": color,
                        "canBeOnAllLines": true
                    },
                    "Triangle": {
                        "text": this._analysis.currentLabelModel.tag,
                        "color": color,
                        "canBeOnSeveralLines": false
                    },
                });
            }

            _handleCursorChangedEvent (cursor) {
              if (this._synchro == undefined) return
              this.currentDate = this._synchro.toDate (
                this.map.toMusicalOnset(cursor)
              )
              this.dispatchEvent(new CustomEvent('current-date-changed'))
            }

            ready () {
                super.ready();
                this.$.canvas.addEventListener("grob-changed", (event) => {
                    this._handleGrobChangedEvent(event.detail)
                })
                this.$.canvas.addEventListener(
                    "cursor-changed", event => {
                      this._handleCursorChangedEvent(this.$.canvas.cursor)
                    }
                )
            }

            _scrollXToOnset(x) {
              return this.map && this.map.toMusicalOnset(x + 500);
            }

            _onsetToScrollX(onset) {
              return this.map && this.map.toGraphicalX(onset) - 500;
            }

            // Wrappers for dez-canvas calls, converts from map units to X values

            setOnsetTarget(onset) {
              // Workaround if map is not loaded, cache this argument to be reloaded when map is loaded 
              this._onsetTarget = onset;
              if (this.map) {
                this.$.canvas.scrollToTarget(this._onsetToScrollX(onset));
              }
            }

            scrollOnsetInView(onset) {
              if (this.map)
                this.$.canvas.scrollPositionInView(this.map.toGraphicalX(onset));
            }

            scrollRangeInView(onset, release) {
              if (this.map)
                this.$.canvas.scrollRangeInView(
                  this.map.toGraphicalX(onset),
                  this.map.toGraphicalX(release)
                );
            }

            _setGrid (positionsData) {
              if (this.isScore()) {
                this.map = new MusicalMap();
                this.map.positions = positionsData["onset-x"]
              } else if (this.isWave()) {
                if (this._synchro == undefined) return
                this.map = new WaveMap(this._synchro);
                this.map.positions = positionsData["date-x"]
              }
              this.map.lastOffset = this.lastOffset
              this.gridData = this._generateGridData(positionsData);
              // If setOnsetTarget was called before map wa loaded, reload it
              if (this._onsetTarget) {
                this.setOnsetTarget(this._onsetTarget);
              }
            }

            _setView (positionsData) {
              if (this.isWave() && this._synchro == null) return
              if (this._view != undefined) {
                this._view.map = this.map
                this._analysis.labels.forEach(label => this._view.redraw(label))
              } else {
                this._view = new ScoreView(this.$.canvas, this.map, this._labelTypes);
                this.dispatchEvent(new CustomEvent ('view-ready'))
              }
            }

            resetView() {
              if (this._view) {
                this._view.resetLabels();
                this._view.deleteLines();
                this._view = undefined;
              }
            }

            _generateGridData (positionsData) {
                let positions;
                if (this.isScore()) {
                    positions = positionsData["onset-x"].map(pos => pos.x);
                } else if (this.isWave()) {
                    positions = this.map.regularGraphicalGrid(
                        this.timeSigDenum == 8 ? 1.5 : 1, // step
                        this.timeSigUpbeat
                    )
                }
                return {
                    "positions": positions,
                    "lines": positionsData.staffs.map(staff => {
                        return {
                            "bottom": staff.bottom,
                            "top": staff.top
                        }
                    })
                };

            }

        }

        customElements.define(DezMusicCanvas.is, DezMusicCanvas);

    </script>

</dom-module>
